import bge
import add_players
import aud
import update_goals

dict = bge.logic.globalDict
scene = bge.logic.getCurrentScene()

def loadLevel():
    scene = bge.logic.getCurrentScene()
    pdict = bge.logic.globalDict
    objList = scene.objects
    mainDir = bge.logic.expandPath("//")
    fileName = mainDir + "levels/" + dict['cur_level'] + '.blend'    
    path = bge.logic.expandPath(fileName)
    try:
        bge.logic.LibLoad(path, 'Scene') 
    except:
        print('trying to load', fileName, 'twice')       

def run(cont):
    own = cont.owner
    scene = bge.logic.getCurrentScene()
    if 'inited' not in own:
        own['inited'] = True
        loadLevel()            
        dict['health'] = 100
        dict['ammo'] = 20
        dict['kills'] = 0
        dict['money'] = 0
        dict['end'] = scene.objects['End']
        dict['paused'] = False
        dict['dead'] = False
        dict['win'] = False
        dict['clip'] = 8
        for x in scene.objects:
            if 'Enemy' in x:
                add_players.addEnemy(x)        
        
        dict['time'] = 0.0
        dict['money_goal'] = 3
        dict['kill_goal'] = 5
        update_goals.update_goals()
        dict['music_volume'] = .8
        
        scenes = bge.logic.getSceneList()
        this_scene = 'overlayText'
        foundScenes = [scene for scene in scenes if scene.name == this_scene]
        if not foundScenes:
            bge.logic.addScene(this_scene)     
            
        dict['money_list'] = []

        mainDir = bge.logic.expandPath("//")
        fileName = mainDir + "sounds/" + str(dict['cur_level']) + '.wav' 
        
        path = bge.logic.expandPath(fileName)
        music = aud.Factory.file(path)

        music_device = aud.device()
        music.loop(-1)
        handler = music_device.play(music)
        handler.loop_count = -1
        #music.loop(100)
        handler.volume = 1
        own['music_control'] = handler

        #scene.world.backgroundColor = [0,0,.01]
        scene.world.ambientColor = [0,0,0]   
        #scene.world.backgroundColor = [1,0,0]         
        scene.world.horizonColor = [0,1,0, 1]
        scene.world.mistColor = [0,0,.002]
        
    if dict['money_list'] == [] and dict['money'] == 0:
        scene = bge.logic.getCurrentScene()
        for x in scene.objects:
            if 'money' in x:
                dict['money_list'].append(x)
    if dict['money'] < dict['money_goal']:
        dist = 10000
        nm = dict['money_list'][0]
        try:
            for x in dict['money_list']:              
                d2 = (dict['user'].worldPosition - x.worldPosition).length
                if d2 < dist:
                    dist = d2
                    nm = x
        except Exception as e: print(e)           
        dict['nearest_money'] = nm

    if dict['dead'] or dict['win']:
        if dict['music_volume'] > 0:
            dict['music_volume'] -= .005
            

        if dict['music_volume'] < 0:
            dict['music_volume'] = 0    
        own['music_control'].volume = dict['music_volume']
            