import bge
from random import randint
from time import clock
from easings import *
import inputs
import os
import scores
import change_level
import smooth_text

def screen_1(life):
	ease_in = 120
	ease_length = 240
	ease_out = 120 + 240 + 120
	if 'intro1' in bge.logic.getSceneList():
		scene = bge.logic.getSceneList()["intro1"]         
		logo = scene.objects['intro2_bk']
	
	if life >= ease_in and life < (ease_in + ease_length):
		tlife = life - ease_in
		a = QuadEaseIn(start=0, end = 1, duration = ease_length)        
		k = a.ease(tlifFe) 
		logo.color = [0,0,0,k]

	if life >= ease_out and life < (ease_out + ease_length):
		tlife = life - ease_out
		a = QuadEaseOut(start=1, end = 0, duration = ease_length)        
		k = a.ease(tlife) 
		logo.color = [0,0,0,k]

def screen_2(life):
	ease_in = 60
	ease_length = 120
	ease_out = 60 + 120 + 60
	if 'intro2' in bge.logic.getSceneList():
		scene = bge.logic.getSceneList()["intro2"]         
		logo = scene.objects['background']

	if life >= ease_in and life < (ease_in + ease_length):
		tlife = life - ease_in
		a = QuadEaseIn(start=1, end = 0, duration = ease_length)        
		k = a.ease(tlife) 
		logo.color = [0,0,0,k]

	if life >= ease_out and life < (ease_out + ease_length):
		tlife = life - ease_out
		a = QuadEaseOut(start=0, end = 1, duration = ease_length)        
		k = a.ease(tlife) 
		logo.color = [0,0,0,k]
		
def menu1_in(life):
	ease_in = 1
	ease_length = 120
	ease_out = 60 + 120 + 60
	if 'menu1' in bge.logic.getSceneList():
		scene = bge.logic.getSceneList()["menu1"]         
		logo = scene.objects['menu1_bk']

		if life >= ease_in and life < (ease_in + ease_length):
			tlife = life - ease_in
			a = QuadEaseIn(start=1, end = 0, duration = ease_length)        
			k = a.ease(tlife) 
			logo.color = [0,0,0,k]
			#print(k, 'screen_in')

		else:
			logo.color = [0,0,0,1]    
	  
def menu1_out(life):
	ease_in = 60
	ease_length = 120
	ease_out = 60 + 120 + 60
	if 'menu1' in bge.logic.getSceneList():
		scene = bge.logic.getSceneList()["menu1"]         
		tlife = life
		a = QuadEaseOut(start=0, end = 1, duration = ease_length)        
		k = a.ease(tlife) 

#====================================
class Transition(object):
	def __init__(self, toState):
		self.toState = toState

	def Execute(self):
		pass
		#print('Transitioning ...', self.toState)
#====================================
State = type("State", (object,), {})

class State(object):
	def __init__(self, FSM):
		self.FSM = FSM
		self.timer = 0
		self.startTime = 0
	def Enter(self):
		self.timer = 0
		self.startTime = int(clock())
	def Execute(self):
		#print('Executing')
		pass
	def Exit(self):
		pass
		#print('Exiting')
		
class Menu1(State):
	def __init__(self,FSM):
		super(Menu1, self).__init__(FSM)

	def Enter(self):
		#print('Preparing menu 1.')
		self.FSM.stateLife = 1
		dict = bge.logic.globalDict
		self.timer = 0
		if 'black_out' in bge.logic.getInactiveSceneNames():
			#bge.logic.addScene('black_out', 1) #1 for overlay                    
			#print('black out')
			pass
		else:
			bge.logic.getSceneList()["black_out"].end()     
			#bge.logic.addScene('black_out', 1) #1 for overlay   
		
		super(Menu1, self).Enter()
		
		
	def Execute(self):        
		dict = bge.logic.globalDict
		self.FSM.stateLife += 1
		#new_scene = 
		
		if 'menu1' in bge.logic.getSceneList():
			scene = bge.logic.getSceneList()["menu1"]  
			scene.objects['levelText'].text = 'select day: <' + str(dict['cur_level']) + '>'
		else:
			bge.logic.addScene('menu1', 1)
		

		if self.FSM.stateLife < 3 and self.FSM.stateLife > 1 and 'black_out' not in bge.logic.getSceneList():
			bge.logic.addScene('black_out', 1)


		if self.FSM.stateLife > 60:
			if dict['kb_en'] == 1 or (dict['aBut'] and not dict['last_aBut']):
				self.FSM.ToTransition('toMenu1out')
			if (dict['kb_ra'] == 1 and dict['last_kb_ra'] == 0) or (dict['lLR'] > .04 and dict['last_lLR'] < .04):
				change_level.level_up()
				#print('level changed to ', dict['cur_level'])
			elif (dict['kb_la'] == 1 and dict['last_kb_la'] == 0) or (dict['lLR'] < -.04 and dict['last_lLR'] > -.04):
				change_level.level_down()
				#print('level changed to ', dict['cur_level'])  

			if (dict['bkBut'] == 1 and dict['last_bkBut'] == 0) or (dict['kb_esc'] > 0 and dict['last_kb_esc'] == 0):
				bge.logic.endGame()
				
	def Exit(self):
		#pass
		if 'black_out' in bge.logic.getSceneList():
			bge.logic.getSceneList()["black_out"].end()  
		#print('Finished menu 1')   


class Menu1out(State):
	def __init__(self,FSM):
		super(Menu1out, self).__init__(FSM) 

	def Enter(self):
		#print('Preparing menu 1out.')
		self.FSM.stateLife = 1
		if 'black_in' in bge.logic.getInactiveSceneNames():
			bge.logic.addScene('black_in', 1) #1 for overlay                    
			#print('black in')
		else:
			bge.logic.getSceneList()["black_in"].end()     
			bge.logic.addScene('black_in', 1) #1 for overlay   

		super(Menu1out, self).Enter()
		
	def Execute(self):
		self.FSM.stateLife += 1
		duration = 120
		dict = bge.logic.globalDict
		menu1_out(self.FSM.stateLife)

		if self.FSM.stateLife == duration:
			self.FSM.ToTransition('toGame')

				
	def Exit(self):
		#print('Finished menu  out')  
		if 'menu1' in bge.logic.getSceneList():
			scene = bge.logic.getSceneList()["menu1"]         
			scene.end()
			#print('ending menu1')  

class PlayingScreen1(State):
	def __init__(self,FSM):
		super(PlayingScreen1, self).__init__(FSM)    

	def Enter(self):
		#print('Preparing to play screen 1.')
		self.FSM.stateLife = 1
		self.timer = 0
		super(PlayingScreen1, self).Enter()
		if 'intro1' in bge.logic.getInactiveSceneNames():
			bge.logic.addScene('intro1', 1) #1 for overlay 
		if 'black_out' in bge.logic.getInactiveSceneNames():
			bge.logic.addScene('black_out', 1) #1 for overlay                    
			#print('black out')

	def Execute(self):
		self.FSM.stateLife += 1
		if self.timer > 0:
			self.timer += 1
			#print('incing timer', self.timer)
		duration = 360
		if self.FSM.stateLife == 280:
			bge.logic.getSceneList()["black_out"].end()
			#print('ending blackout')

		dict = bge.logic.globalDict
		if self.FSM.stateLife == duration and self.timer == 0:
			if 'black_in' in bge.logic.getInactiveSceneNames():
				bge.logic.addScene('black_in', 1) #1 for overlay 
				#print('adding')
			else:
				bge.logic.getSceneList()["black_in"].end()     
				bge.logic.addScene('black_in', 1) #1 for overlay 
				#print('ending and adding')
			if 'black_out' not in bge.logic.getInactiveSceneNames():    
				bge.logic.getSceneList()["black_out"].end()    
			self.timer = 1
			#print('black in')

		if (dict['kb_en'] == 1 or dict['aBut'] and self.timer == 0):
			if 'black_in' not in bge.logic.getInactiveSceneNames():
				bge.logic.getSceneList()["black_in"].end()     
				#print('ending and adding')
			if 'black_out' not in bge.logic.getInactiveSceneNames():    
				bge.logic.getSceneList()["black_out"].end()    
			self.timer = 500
			#print('exiting early')

		if self.FSM.stateLife == duration:
			self.timer = 1        
		if self.timer > 500:
			#print('timer met')
			self.FSM.ToTransition('toScreen2')

	def Exit(self):
		#print('Finished playing screen 1') 
		if 'intro1' in bge.logic.getSceneList():
			scene = bge.logic.getSceneList()["intro1"]         
			scene.end()
			#print('ending intro1')

class PlayingScreen2(State):
	def __init__(self,FSM):
		super(PlayingScreen2, self).__init__(FSM)    
		
	def Enter(self):
		#print('Preparing to play screen 2.')
		self.FSM.stateLife = 1
		self.timer = 0
		super(PlayingScreen2, self).Enter()
		if 'intro2' in bge.logic.getInactiveSceneNames():
			scene = bge.logic.addScene('intro2', 1) #1 for overlay 
		if 'black_out' in bge.logic.getInactiveSceneNames():
			bge.logic.addScene('black_out', 1) #1 for overlay                    
			#print('black out')
		if 'black_in' not in bge.logic.getInactiveSceneNames():
			bge.logic.getSceneList()["black_in"].end()
			
	def Execute(self):
		self.FSM.stateLife += 1
		if self.timer > 0:
			self.timer += 1
			#print('incing timer', self.timer)
		duration = 360
		if self.FSM.stateLife == 280:
			bge.logic.getSceneList()["black_out"].end()
			#print('ending blackout')

		dict = bge.logic.globalDict
		if self.FSM.stateLife == duration and self.timer == 0:
			if 'black_in' in bge.logic.getInactiveSceneNames():
				bge.logic.addScene('black_in', 1) #1 for overlay 
				#print('adding')
			else:
				bge.logic.getSceneList()["black_in"].end()     
				bge.logic.addScene('black_in', 1) #1 for overlay 
				#print('ending and adding')
			if 'black_out' not in bge.logic.getInactiveSceneNames():    
				bge.logic.getSceneList()["black_out"].end()    
			self.timer = 1
			#print('black in')

		if (dict['kb_en'] == 1 or dict['aBut'] and self.timer == 0):
			if 'black_in' not in bge.logic.getInactiveSceneNames():
				bge.logic.getSceneList()["black_in"].end()     
				#print('ending and adding')
			if 'black_out' not in bge.logic.getInactiveSceneNames():    
				bge.logic.getSceneList()["black_out"].end()    
			self.timer = 500
			#print('exiting early')

		if self.FSM.stateLife == duration:
			self.timer = 1        
		if self.timer > 500:
			#print('timer met')
			self.FSM.ToTransition('toMenu1')

	def Exit(self):
		#print('Finished playing screen 2') 
		if 'intro2' in bge.logic.getSceneList():
			scene = bge.logic.getSceneList()["intro2"]         
			scene.end()
			#print('ending intro2')

class Sleep(State):
	
	def __init__(self,FSM):
		super(Sleep, self).__init__(FSM)  
		
	def Enter(self):
		#print('Initializing.')
		super(Sleep, self).Enter()
		self.FSM.stateLife = 1
		
	def Execute(self):
		#print('Starting up.', self.FSM.stateLife)
		self.FSM.stateLife += 1
		duration = 4
		if self.FSM.stateLife > duration:
			self.FSM.ToTransition('toScreen1')				
			
	def Exit(self):
		pass
		#print('Going to screen 1.')   
		
		
class Game(State):
	
	def __init__(self,FSM):
		super(Game, self).__init__(FSM)  
		
	def Enter(self):
		#print('Initializing game.')
		super(Game, self).Enter()
		self.FSM.stateLife = 1
		
		if 'level' in bge.logic.getInactiveSceneNames():
			bge.logic.addScene('level', 1) #1 for overlay 

		if 'black_out' in bge.logic.getInactiveSceneNames():
			bge.logic.addScene('black_out', 1) #1 for overlay                    
			#print('black out')
		else:
			bge.logic.getSceneList()["black_out"].end()     
			bge.logic.addScene('black_out', 1) #1 for overlay   			             
		
		
	def Execute(self):
		dict = bge.logic.globalDict
		self.FSM.stateLife += 1
		
		if (dict['bkBut'] == 1 and dict['last_bkBut'] == 0) or (dict['kb_esc'] > 0 and dict['last_kb_esc'] == 0) and dict['paused'] == True:
			dict['dead'] = True 
			sc = bge.logic.getSceneList()["level"] 
			bge.logic.getSceneList()["pause"].end()	
			sc.resume()

		if (dict['stBut'] == 1 and dict['last_stBut'] == 0) or (dict['kb_en'] == 1 and dict['last_kb_en'] == 0):
			if dict['paused'] == True:
				#print('resuming')
				dict['paused'] = False        
				sc = bge.logic.getSceneList()["level"] 
				sc.resume()
				bge.logic.getSceneList()["pause"].end()				
			else:
				#print('pausing')
				dict['paused'] = True        
				sc = bge.logic.getSceneList()["level"] 
				sc.suspend()
				bge.logic.addScene('pause', 1)
		#dying
		if dict['dead']:            
			self.FSM.ToTransition('toDead')
		
		#winning
		if dict['win']:        
			self.FSM.ToTransition('toWinner')

		if not dict['dead'] and self.FSM.stateLife > 120:
			if 'black_in' in bge.logic.getSceneList():
				bge.logic.getSceneList()["black_in"].end()                    

	def Exit(self):
		pass
		#print('Going to screen 1.')                  
						   
class Dead(State):
	def __init__(self,FSM):
		super(Dead, self).__init__(FSM)  
		
	def Enter(self):
		#print('Initializing.')
		super(Dead, self).Enter()
		self.FSM.stateLife = 1

		if 'black_in' in bge.logic.getInactiveSceneNames():
			bge.logic.addScene('black_in', 1) #1 for overlay                    
			#print('black in')
		else:
			bge.logic.getSceneList()["black_in"].end()     
			bge.logic.addScene('black_in', 1) #1 for overlay   			

	def Execute(self):

		self.FSM.stateLife += 1
		duration = 300
		dict = bge.logic.globalDict

		if self.FSM.stateLife > duration:
			if 'black_in' in bge.logic.getInactiveSceneNames():
				bge.logic.addScene('black_in', 1)
			   
			if self.FSM.stateLife == 360:    
				bge.logic.addScene('dead', 1)
				bge.logic.getSceneList()["level"].end()
				bge.logic.getSceneList()["overlayText"].end()                
				dict['dead'] = False
				dict['health'] = 100
				dict['win'] = False

			if (dict['kb_en'] == 1 or (dict['aBut'] and not dict['last_aBut'])) and self.FSM.stateLife > 360:
				dict['win'] = False
				self.FSM.ToTransition('toMenu1')
				mainDir = bge.logic.expandPath("//")
				fileName = mainDir + "levels/" + dict['cur_level'] + '.blend'    
				path = bge.logic.expandPath(fileName)
				try:
					bge.logic.LibFree(path) 
				except Exception as e: 
					#print(e)
					#print('failed to unload', fileName) 
					pass                                  
				
	def Exit(self):
		#print('exiting from dead.')                              
		bge.logic.getSceneList()["black_in"].end()                           
		bge.logic.getSceneList()["dead"].end()                                   
					 
class Winner(State):
	def __init__(self,FSM):
		super(Winner, self).__init__(FSM)  
		
	def Enter(self):
		#print('Initializing.Winner')
		super(Winner, self).Enter()
		self.FSM.stateLife = 1
		
	def Execute(self):
		self.FSM.stateLife += 1
		duration = 300
		dict = bge.logic.globalDict
		if self.FSM.stateLife > duration:
			if 'black_in' in bge.logic.getInactiveSceneNames():
				bge.logic.addScene('black_in', 1)
			#print(dict['score'])   
			if self.FSM.stateLife == 360:    
				bge.logic.addScene('winner', 1)
				bge.logic.getSceneList()["level"].end()
				bge.logic.getSceneList()["overlayText"].end()  
				dict['dead'] = False
				dict['health'] = 100
				dict['win'] = False
			if (dict['kb_en'] == 1 or (dict['aBut'] and not dict['last_aBut'])) and self.FSM.stateLife > 360:
				dict['win'] = False
				self.FSM.ToTransition('toMenu1')
				mainDir = bge.logic.expandPath("//")
				fileName = mainDir + "levels/" + dict['cur_level'] + '.blend'    
				path = bge.logic.expandPath(fileName)
				try:
					bge.logic.LibFree(path) 
				except Exception as e: 
					pass
					#print(e)
					#print('failed to unload', fileName)                                   
				
	def Exit(self):
		#print('exiting from Winner.')                              
		bge.logic.getSceneList()["black_in"].end()                           
		bge.logic.getSceneList()["winner"].end()                       
#===================================
						

class FSM(object):
	def __init__ (self, character):
		self.char = character
		self.states = {}
		self.transitions = {}
		self.curState = None
		self.prevState = None
		self.trans = None
		self.stateLife = 0
		
	def AddTransition(self, transName, transition):
		self.transitions[transName] = transition
	
	def AddState(self, stateName, state):
		self.states[stateName] = state        
		
	def SetState(self, stateName):
		self.prevState = self.curState
		self.curState = self.states[stateName]
		
	def ToTransition(self, toTrans):
		self.trans = self.transitions[toTrans]
		
	def Execute(self):
		if (self.trans):
			self.curState.Exit()
			self.trans.Execute()
			self.SetState(self.trans.toState)
			self.curState.Enter()
			self.trans = None        
		self.curState.Execute()    
				
#====================================
Char = type("Char",(object,),{})

class FuryRoad(Char):
	def __init__(self):
		self.FSM = FSM(self)
		
		##STATES
		self.FSM.AddState("Sleep", Sleep(self.FSM))
		self.FSM.AddState('Menu1', Menu1(self.FSM))
		self.FSM.AddState('Menu1out', Menu1out(self.FSM))
		self.FSM.AddState('PlayingScreen1', PlayingScreen1(self.FSM))
		self.FSM.AddState('PlayingScreen2', PlayingScreen2(self.FSM))
		self.FSM.AddState('Game', Game(self.FSM))
		self.FSM.AddState('Dead', Dead(self.FSM))
		self.FSM.AddState('Winner', Winner(self.FSM))
		#TRANSITIONS
		self.FSM.AddTransition('toSleep', Transition('Sleep'))
		self.FSM.AddTransition('toMenu1', Transition('Menu1'))
		self.FSM.AddTransition('toMenu1out', Transition('Menu1out'))
		self.FSM.AddTransition('toScreen1', Transition('PlayingScreen1'))
		self.FSM.AddTransition('toScreen2', Transition('PlayingScreen2'))
		self.FSM.AddTransition('toGame', Transition('Game'))
		self.FSM.AddTransition('toDead', Transition('Dead'))        
		self.FSM.AddTransition('toWinner', Transition('Winner'))        
		
		if self.FSM.curState == None:
			self.FSM.SetState('Sleep')
			#print('setting none')
	
	def Execute(self):
		self.FSM.Execute()    
#====================================     
r = FuryRoad()
def main(cont):
	own = cont.owner   
	dict = bge.logic.globalDict
	if 'inited' not in own:
		own['inited'] = True
		own['frame'] = 0
		dict['cur_level'] = 'monday'
		dict['dead'] = False
		dict['win'] = False
		dict['score'] = 0
		scores.load_highscores(cont)
		scene = bge.logic.getCurrentScene()
		#scene.world.backgroundColor = [0,1,0]
		
	inputs.main(cont)
	r.Execute()    
	
	own['frame'] += 1
