import bge
import math
from mathutils import Vector
#import numpy
import aud
import random

def ai(cont):
    #pass
    own = cont.owner
    scene = bge.logic.getCurrentScene()
    dict = bge.logic.globalDict
    c2 = own.children['control2']
    arm = c2.children['metarig'] 
    gray = cont.sensors['gRay']   
    toPlayer = own.getDistanceTo(dict['user'])
    if not own['dead'] and toPlayer < own['sleepDist']:
        own['paused'] = False
        ground = True    
        if gray.positive:
            dist = own.worldPosition.z - gray.hitPosition[2]

            if dist > .37:
                ground = False
                own['air_timer'] += 1
                if dist - own['gdist'] > 0:
                    arm.playAction('walk2', 20,20, layer=3, play_mode=1, speed=1)
                else:
                    arm.stopAction(4)
                    if own['blendamt'] > .05:
                        own['blendamt'] -= .05
                    
                    arm.playAction('walk2', 60,60, layer=4, play_mode=1, speed=1, layer_weight=own['blendamt'])    
                own['last_air'] = True
            
            else:    
                if own['last_air'] == True:
                    arm.playAction('land_v2', 1,40, layer=5, play_mode=0, speed=4)
                    own['last_air'] = False
                    #print('landing')
                own['gdist'] = 0  
                arm.stopAction(3)
                arm.stopAction(4) 
                own['blendamt'] = 1
                own['air_timer'] = 0
                
            own['gdist'] = dist  
            move_away_dist = 2
            player_list = []
            for x in scene.objects:
                if 'player' in x and x != own:
                    player_list.append(x)
                    
            for x in player_list:
                distx = own.worldPosition.x - x.worldPosition.x
                disty = own.worldPosition.y - x.worldPosition.y

            own.alignAxisToVect([0.0,0.0,1.0], 2, .05) 
            yvel = .05
            if own.linearVelocity.x > .02 or own.linearVelocity.x < -.02:
                #print('walk2')
                arm.stopAction(0)
                #arm.playAction('walk2', 1,60, layer=10, play_mode=1, speed=1, layer_weight=1) 
                arm.playAction('walk2', 1,80, layer=1, play_mode=1, speed=1, layer_weight=0.0) 
            else:
                arm.stopAction(1)
                arm.playAction('idle_v2', 1,80, layer=0, play_mode=1, speed=1, blend_mode=0)                                      
            if own['hit']:
                foo = ['shot1c', 'shot2c', 'shot3c']
                sho = random.choice(foo)
                
                arm.playAction(sho, 0,20, layer=2, play_mode=0, speed=1, blend_mode=0)   
                own['hit'] = False   
                shot = own['bloodEmpty']
                #scene.addObject['shotFire']
                expl = scene.addObject('shotBlood', shot, 20)
                own['health'] -= 20
                if own['health'] < 1:
                    own['dead'] = True
                    arm.stopAction(4)
                    arm.playAction('dead_v2', 0,800, layer=5, play_mode=0, speed=1, blend_mode=0)   

                    
            dist2 = 0    
            steer = cont.actuators['Steering']
            
            if toPlayer < own['shootDist']:
                state = 'shoot' 
            elif toPlayer < own['attackDist']:
                state = 'attack'
            else:
                state = 'idle'                  

            if state == 'flee':
                steer.behavior = 2
                steer.target = player_list[0]
                steer.distance = 3
                cont.activate(steer)
                vectTo = own.getVectTo(player_list[0].worldPosition)
                own.alignAxisToVect(-vectTo[1], 0, own['align_speed'])  
            if state == 'attack':
                steer.behavior = 2
                steer.target = player_list[0]
                steer.distance = 3
                cont.activate(steer)
                vectTo = own.getVectTo(dict['user'].worldPosition)              
                own.alignAxisToVect(vectTo[1], 0, own['align_speed'])  
                own.linearVelocity.x = own['attack_speed']
                own.linearVelocity.y = 0
                
            if state == 'position':
                far_obj = scene.objects[dict['far_obj']]
                steer.behavior = 1
                steer.target = dict['far_obj']
                steer.distance = 1
                cont.activate(steer)   
                vectTo = own.getVectTo(far_obj.worldPosition)
                own.alignAxisToVect(vectTo[1], 0, .05)   

            if state == 'position_npc':
                far_obj = scene.objects[own['pos']]
                steer.behavior = 1
                steer.target = far_obj
                steer.distance = 1
                cont.activate(steer)   
                vectTo = own.getVectTo(far_obj.worldPosition)
                own.alignAxisToVect(vectTo[1], 0, .05)                                                  

            if state == 'shoot':
                vectTo = own.getVectTo(dict['user'].worldPosition)              
                own.alignAxisToVect(vectTo[1], 0, own['align_speed'])  
                arm.playAction('aim', 0,0, layer=4, play_mode=1, speed=1)
                shottime = own['life'] - own['shot_frame']  
                if shottime < 60: 
                    arm.playAction('aim', 0,0, layer=4, play_mode=1, speed=1)
                
                Axis = 0
                Distance = 50
                End = own.worldPosition + (own.worldOrientation.col[Axis]*Distance)
                Start = own.worldPosition
                localRay = own.rayCast(End, Start, 0,'player', 0, 0, 0)                     

                if shottime > 60 and localRay[0]:       
                    shot = scene.objects['shotEmpty']
                    shot = own['shotEmpty']
                    expl = scene.addObject('shotFire', shot, 10)
                    own['shot_frame'] = own['life']
                    playShot(cont)
                    targ = dict['user']
                    shottime = own['life'] - own['shot_frame']  
                    Start = own.worldPosition
                    End = targ  
                    
                    localRay[0]['hit'] = True           
            
            if state == 'idle':
                vectTo = own.getVectTo(dict['user'].worldPosition)              
                own.alignAxisToVect(vectTo[1], 0, own['align_speed'])  
            own.alignAxisToVect([0.0,0.0,1.0], 2, .2)

    elif toPlayer > own['sleepDist']:
        if 'paused' not in own:
            own['paused'] = True
        if not own['paused']:
            own['paused'] = True
            c2 = own.children['control2']
            arm = c2.children['metarig']            
            arm.stopAction(0)
            arm.stopAction(1)                   
            arm.stopAction(2)
            arm.stopAction(3)
            arm.stopAction(4)                                   
    else:
        if 'fadeout' not in own:
            own['fadeout'] = 1.0        
        x = own.children['control2']
        y = x.children['metarig']       
        z = y.children['player_mesh']
        z2 = y.children['skin']
        z3 = y.children['pants']
        z.color[3] = own['fadeout']     
        z2.color[3] = own['fadeout']        
        z3.color[3] = own['fadeout']        
        own['fadeout'] -= .01 
        if own['fadeout'] < 0:
            z.endObject()
            own.endObject()
            dict['kills'] += 1
            
    if own['life'] < 30:
        own.worldPosition.z = 3
                        
def sun(cont):
    own = cont.owner
    dict = bge.logic.globalDict
    try:
        own.worldPosition.x = dict['user'].worldPosition.x
        own.worldPosition.y = dict['user'].worldPosition.y              
    except Exception as e: print(e)
                
def playShot(cont):
    mainDir = bge.logic.expandPath("//")
    fileName = mainDir + "sounds/" + "shot.wav"  
    path = bge.logic.expandPath(fileName)
    sound = aud.Factory.file(path)
    scene = bge.logic.getCurrentScene()
    own = cont.owner
    sound_device = aud.device()
    sound_device.distance_model = aud.AUD_DISTANCE_MODEL_LINEAR
    sound_device.listener_location = own.worldPosition
    sound_device.listener_velocity = own.getLinearVelocity()
    sound_handle = sound_device.play(sound)
    sound_handle.relative = False
    sound_handle.location = own.worldPosition
    sound_handle.velocity = own.getLinearVelocity()
    sound_handle.distance_maximum = 100
    sound_handle.distance_reference = 1

def playPickup(cont):
    mainDir = bge.logic.expandPath("//")
    fileName = mainDir + "sounds/" + "pickup.wav"   
    path = bge.logic.expandPath(fileName)
    sound = aud.Factory.file(path)
    scene = bge.logic.getCurrentScene()
    own = cont.owner
    sound_device = aud.device()
    sound_device.distance_model = aud.AUD_DISTANCE_MODEL_LINEAR
    sound_device.listener_location = own.worldPosition
    sound_device.listener_velocity = own.getLinearVelocity()
    sound_handle = sound_device.play(sound)
    sound_handle.relative = False
    sound_handle.location = own.worldPosition
    sound_handle.velocity = own.getLinearVelocity()
    sound_handle.distance_maximum = 100
    sound_handle.distance_reference = 1
            
def main2(cont):
    own = cont.owner
    scene = bge.logic.getCurrentScene()
    dict = bge.logic.globalDict
    c2 = own.children['control2']
    arm = c2.children['metarig']
    aKey = dict['kb_la']
    dKey = dict['kb_ra']
    eKey = dict['kb_e']
    qKey = dict['kb_q']
    spaceKey = dict['kb_space']
    shiftKey = dict['kb_lsh']
    gray = cont.sensors['gRay']
    walk = False
    
    #initialize
    try: 
        a = dict['cam_targ']
    except Exception as e: 
        print(e)
        dict['cam_targ'] = own    
    
    player_list = []
    for x in scene.objects:
        if 'player' in x and x != own:
            #print(x)
            if 'dead' in x:
                if not x['dead']:
                    player_list.append(x) 
    try:        
        pdist = own.getDistanceTo(player_list[0])
    except Exception as e: 
        print(e)
        pdist = 0    
    team1 = []
    for x in scene.objects:
        if 'team' in x:
            if x['team'] == 1:
                team1.append(x)    
    
    ground = True    
    if gray.positive:

        dist = own.worldPosition.z - gray.hitPosition[2]
        
        if dist > .37:
            ground = False
            own['air_timer'] += 1
            if dist - own['gdist'] > 0:
                arm.playAction('walk2', 20,20, layer=3, play_mode=1, speed=1)
                if (dict['yBut'] == 1 or eKey == 1) and own['air_timer'] > 5 and dist > .9:
                    arm.playAction('flip', 1, 20, layer=5, play_mode=0, speed=1.5)
            else:
                arm.stopAction(4)
                if own['blendamt'] > .05:
                    own['blendamt'] -= .05
                
                arm.playAction('walk2', 60,60, layer=4, play_mode=1, speed=1, layer_weight=own['blendamt'])    
            own['last_air'] = True
        else:
            
            if own['last_air'] == True:
                arm.playAction('land_v2', 1,40, layer=5, play_mode=0, speed=4)
                own['last_air'] = False
                #print('landing')
            own['gdist'] = 0  
            arm.stopAction(3)
            arm.stopAction(4) 
            own['blendamt'] = 1
            own['air_timer'] = 0
            
        own['gdist'] = dist  
        #print('ray is on ground', dist)             
    if ground == True:        
        walkspeed = 1
        tilt = .015
        if dict['kb_ua'] or dict['lUD'] < -.04:
            own.linearVelocity.y = own.linearVelocity.y * .5
            if shiftKey > 0 or dict['aBut'] == 1:
                own.linearVelocity.x = 7
                walkspeed = 2
                walk = True
            else:    
                own.linearVelocity.x = 3
                walk = True
            own['wKey_timer'] += 1    
            if own['wKey_timer'] < 20:
                own.applyRotation([0, tilt, 0], True)
        else:
            own['wKey_timer'] = 0        
        if aKey > 0 or dict['lLR'] < -.04:
            own.linearVelocity.y = 1
            own['aKey_timer'] += 1  
            if own['aKey_timer'] < 20:
                own.applyRotation([-tilt, 0, 0],True)         
        else:
            own['aKey_timer'] = 0        
        if dKey > 0 or dict['lLR'] > .04:
            own.linearVelocity.y = -1  
            walk = True
            own['dKey_timer'] += 1  
            if own['dKey_timer'] < 20:
                own.applyRotation([tilt, 0, 0],True)                
        else: 
            own['dKey_timer'] = 0  
            
        if walk == 1:
            pass
        else:
            if own['walk_frame'] != 0 and dict['lLR'] < .04 and dict['lLR'] > -.04:
                own['wKey_timer'] = 0
                own['aKey_timer'] = 0
                own['dKey_timer'] = 0               
        
        if own['last_walk'] == True:  
            if own.linearVelocity.x < .5 and (own['walk_frame'] == 80 or own['walk_frame'] == 39):
                own['last_walk'] = False
                own['walk_frame'] = 0
                arm.stopAction(1)
                arm.stopAction(0)
            else:
                pass
        
        if own['walk_frame'] > 80:
            own['walk_frame'] -= 80
        #print(own['walk_frame'], 'walkframe', own['blendamt']) 
        wf = float(own['walk_frame'] )   
        if own.linearVelocity.x > .5:
            walk = 1
            
        if walk == True:
            speed = 1
            own['walk_frame'] += 1
            own['walk2'] = True
            if walkspeed == 2:
                own['walk_frame'] += 1  
            arm.playAction('walk2', wf,80, layer=1, play_mode=1, speed=walkspeed, layer_weight=0.0) 
            own['last_walk'] = walk 
        else:
            if own['last_walk'] == True and walk == False:
                own['walk_frame'] += 1 
                #print('walk______out')
                if own.linearVelocity.x < .5 and (own['walk_frame'] == 80 or own['walk_frame'] == 39):
                    own['walk_frame'] = 0
                    own['last_walk'] = False
                    arm.stopAction(1)                    
            pass
            
        if dict['kb_space'] == 1 or dict['bBut'] == 1:
            own.linearVelocity.z = 7    
               

        own.linearVelocity.z = own.linearVelocity.z + -.1  
        v = own.linearVelocity
        angley = math.atan(v.y)
        anglex = math.atan(v.x)
        yvel = own.linearVelocity.y
        yvel = yvel *.05
        if own.linearVelocity.y > .01 or own.linearVelocity.y < -.01:
            own.applyRotation([0,0,yvel], True)
        arm.playAction('idle_v2', 1,80, layer=0, play_mode=1, layer_weight=1, speed=1, blend_mode=0)       
        own.alignAxisToVect([0.0,0.0,1.0], 2, .05)
        


        if (dict['yBut'] == 1 and not dict['last_yBut']) or eKey == 1:
            arm.playAction('roll', 1, 40, layer=7, play_mode=0, speed=3)
            #own.applyForce([1000,0,0], True)
        if arm.isPlayingAction(7):    
            own.linearVelocity.x = 5
            #pass
        #print('linearVelocity', own.linearVelocity)

    else:
        arm.stopAction(0)
        arm.stopAction(1)
        yvel = own.linearVelocity.y
        yvel = yvel *.05

        if dKey > 0 or dict['lLR'] > .04:
            own.applyRotation([0,0,-.1], True)             
        if aKey > 0 or dict['lLR'] < -.04:
            own.applyRotation([0,0,.1], True)                
            
    cam = scene.active_camera
    if dict['rLR'] > .04:
        cont.activate(cont.actuators['camRight']) 
    else:
        cont.deactivate(cont.actuators['camRight']) 
    if dict['rLR'] < -.04:
        cont.activate(cont.actuators['camLeft']) 
    else:
        cont.deactivate(cont.actuators['camLeft'])  
        
    shottime = own['life'] - own['shot_frame']         
    if ((dict['rTrig'] > .04 and dict['lTrig'] > .04) or (dict['kb_a'] and dict['kb_d'])) and shottime > 30 and dict['ammo'] > 0 and not arm.isPlayingAction(6):
        own['ammo'] -= 1
        dict['clip'] -= 1
        dict['ammo'] = own['ammo']
        shot = own['shotEmpty']
        expl = scene.addObject('shotFire', shot, 10)
        own['shot_frame'] = own['life']
        playShot(cont)
        targ = None
        ogdist = 10000
        for x in team1:
            dist = own.getDistanceTo(x)
            if dist < ogdist:
                ogdist = dist
                targ = x
        if targ != None:
            Start = own.worldPosition
            End = targ              
            Axis = 0
            Distance = 50
            End = own.worldPosition + (own.worldOrientation.col[Axis]*Distance)
            Start = own.worldPosition
            localRay = own.rayCast(End, Start, 0, 'player', 1, 0, 0, 53247)                    
            if localRay[0]:
                localRay[0]['hit'] = True
        
    if dict['lTrig'] > .04 or dict['kb_a']:              
        targ = None
        ogdist = 10000
        for x in team1:
            dist = own.getDistanceTo(x)
            if dist < ogdist:
                ogdist = dist
                targ = x
        if targ != None:        
            vectTo = own.getVectTo(targ.worldPosition)
            own.alignAxisToVect(vectTo[1], 0, .1) 
            dict['aimCam'] = True
            dict['aimObj'] = targ
            arm.playAction('aim', 0,0, layer=4, play_mode=1, speed=1)
        
    else:
        dict['aimCam'] = False
        try:
            pass
        except Exception as e: print(e)
            
    dist = 0
    far_obj = None
    
    if own['hit']:
        foo = ['shot1c', 'shot2c', 'shot3c']
        sho = random.choice(foo)        
        arm.playAction(sho, 0,20, layer=2, play_mode=0, speed=1, blend_mode=0)   
        own['hit'] = False   
        shot = own['bloodEmpty']
        expl = scene.addObject('shotBlood', shot, 20)
        dict['health'] -= 20
        if dict['health'] < 0:
            dict['health'] = 0
        if dict['health'] < 1:
            own['health'] = 0
            own['dead'] = True
            arm.playAction('dead_v2', 0,800, layer=5, play_mode=0, speed=1, blend_mode=0)                                  
            dict['dead'] = True

    hitObject = cont.sensors['pickupCollision'].hitObject       
    if hitObject:
        
        if 'active' in hitObject:   
            if hitObject['active']:
                def do_color():
                    hitObject['active'] = False 
                    hitObject.endObject()

                if dict['health'] < 100:
                    if 'health' in hitObject:
                        playPickup(cont)                
                        dict['health'] += 30
                        if dict['health'] > 100:
                            dict['health'] = 100
                        do_color()
                if own['ammo'] < 30:                            
                    if 'ammo' in hitObject:
                        playPickup(cont) 
                        if own['ammo'] == 0:
                            arm.playAction('reload', 0,30, layer=6, play_mode=0, speed=1, blendin=.5)                         
                        own['ammo'] += 10
                        if own['ammo'] > 30:
                            own['ammo'] = 30                                            
                        dict['ammo'] = own['ammo']
                        do_color()
                if 'money' in hitObject:
                    do_color()
                    playPickup(cont)                
                    own['money'] += 1
                    dict['money'] += 1
                    dict['money_list'].remove(hitObject)
                
                if 'end' in hitObject:
                    print('win_loc', dict['kills'], dict['money'])
                if 'end' in hitObject and dict['kills'] >= dict['kill_goal'] and dict['money'] >= dict['money_goal'] and hitObject['active'] == True:
                    dict['win'] = True
                    hitObject['active'] = False
                    own.linearVelocity.x = 0
                    own.linearVelocity.y = 0
                    arm.playAction('idle_v2', 1,80, layer=4, play_mode=1, speed=1, blend_mode=0)  
                    dict['score'] = 0
                    ns = ((600 - dict['time']) + (dict['kills'] * 4) + (dict['money'] * 4) ) * 10 
                    dict['score'] = int(ns)

    local = own.worldOrientation.inverted() * (dict['end'].worldPosition - own.worldPosition) 
    dict['radarRot'] = own.getVectTo(dict['end'].worldPosition)
    if dict['money'] < dict['money_goal']:
        rot = own.getVectTo(dict['nearest_money'].worldPosition)
        scene.objects['arrow.001'].alignAxisToVect(rot[1], 2, .05)      
        scene.objects['arrow.001'].color = [1,1,0,1]
    elif dict['kills'] < dict['kill_goal']:
        targ = None
        ogdist = 10000
        for x in team1:
            dist = own.getDistanceTo(x)
            if dist < ogdist:
                ogdist = dist
                targ = x
        try:
            rot = own.getVectTo(targ.worldPosition)
            scene.objects['arrow.001'].alignAxisToVect(rot[1], 2, .05)      
            scene.objects['arrow.001'].color = [1,0,0,1]
        except:
            pass

    else:
        scene.objects['arrow.001'].alignAxisToVect(dict['radarRot'][1], 2, .05) 
        scene.objects['arrow.001'].color = [0,1,0,1]
                
    scene.objects['arrow.001'].alignAxisToVect([0.0, 0.0, 1.0], 2, .03)
    
    dict['time'] = own['life'] / 60
    if own['life'] < 30:
        own.worldPosition.z = 3

    if dict['clip'] == 0 or ((dict['xBut'] and not dict['last_xBut']) or dict['kb_q'] == 1):
        if dict['ammo'] > 0 and dict['clip'] < 8:
            arm.playAction('reload', 0,30, layer=6, play_mode=0, speed=1, blendin=.5)            
            if dict['ammo'] > 7:
                dict['clip'] = 8
            else:
                dict['clip'] += dict['ammo']    
                        
def main(cont):

    own = cont.owner   
    dict = bge.logic.globalDict
    scene = bge.logic.getCurrentScene()
    
    if 'inited' not in own:
        print('init player')
        own['inited'] = 1
        own['dKey_timer'] = 0
        own['aKey_timer'] = 0
        own['wKey_timer'] = 0
        own['walk_frame'] = 0.0
        own['last_walk'] = False
        own['last_walk_timer'] = 0
        own['blendamt'] = 0.0
        own['gdist'] = 0.0
        own['last_air'] = False
        own['air_timer'] = 0
        own['throwTimer'] = 0
        own['queueChange'] = False 
        own['player'] = True  
        dict['aimCam'] = False 
        own['shot_frame'] = 0
        own['life'] = 0
        own['dead'] = False

    if not dict['dead'] and not dict['win']:     
        if own['controlled'] == True:
            main2(cont)
        else:
            ai(cont)      

        own['life'] += 1